/* Header "globals.h" for toaster Application */

#include <Ph.h>
#include <Pt.h>

// Toaster I/O port
#define TOASTER_PORT	0x400

// Toaster I/O port bit definitions
#define ELEMENT_ON		0x01
#define TOAST_EJECT		0x02

#define NUM_EVENTS		5

// Event types
#define E_OVERTEMP		0
#define E_TOAST			1
#define E_EJECT			2
#define E_SLIDER		3
#define E_TIMER			4

#define NUM_STATES		2

// Toaster state numbers
#define S_MENU			0
#define S_TOASTING		1

#ifdef DEFINE_GLOBALS

#define GLOBAL
#define INIT(x) = x

#else

#define GLOBAL extern
#define INIT(x)

#endif

/* toaster variables */
GLOBAL ApDBase_t		*toaster_db;
GLOBAL PtWidget_t		*curr_toast;
GLOBAL int				curr_shade;
GLOBAL PtWidget_t		*big_toast;
GLOBAL PtWidget_t		*inside;
GLOBAL int				big_shade;
GLOBAL int				req_shade;
GLOBAL int				req_timer;
GLOBAL int				tm_proxy;
GLOBAL timer_t			tm_id;

/* Global state of toaster */
GLOBAL int				state;
