/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 0.82B */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <signal.h>
#include <time.h>
#include <sys/proxy.h>
#include <sys/kernel.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

#define DEFINE_GLOBALS

/* Local headers */
#include "globals.h"
#include "abimport.h"
#include "proto.h"

int
toaster_init( int argc, char *argv[] )

	{

	/* eliminate 'unreferenced' warnings */
	argc = argc, argv = argv;

	/* not too big... */
	PgSetDrawBufferSize( 8192 );

	/* open database of toast slices */
	toaster_db = ApOpenDBase( ABM_toast_icons );

	/* setup handler for external timer events */
	PtAppAddInput( NULL, 0, toaster_event_handler, NULL );

	return( Pt_CONTINUE );

	}

int
toaster_event_handler( void *data, pid_t pid, void *message, ushort_t size )

	{

	/* eliminate 'unreferenced' warnings */
	data = data, message = message, size = size;

	/* only handle our timer */
	if ( pid == tm_proxy )
		process_event( E_TIMER, 1 );
	
	return( Pt_CONTINUE );
	}

void
timer_on( int seconds )

	{
	struct	sigevent	event;
	struct	itimerspec	timer;

	if ( !tm_proxy ) {
		if ( -1 == ( tm_proxy = qnx_proxy_attach( 0, 0, 0, -1 ) ) )
			return;
		}

	event.sigev_signo = -tm_proxy;
	if ( -1 == ( tm_id = timer_create( CLOCK_REALTIME, &event ) ) )
		return;

	/* set timer for 'seconds' */
	timer.it_value.tv_sec		= (long) seconds;
	timer.it_value.tv_nsec		= 0L;
	timer.it_interval.tv_sec	= (long) seconds;
	timer.it_interval.tv_nsec	= 0L;
	timer_settime( tm_id, 0, &timer, NULL );

	}

void
timer_off( )

	{

	/* remove timer */
	if ( tm_id ) {
		timer_delete( tm_id );
		tm_id = 0;
		}

	}

